/* This sketch example shows how to get one simple data uit of an Openweather JSON string. 
 * You need to create an account by openweathermap.org for the key.
 * This example can by modify for other site's or fields.
 * If you need more fields out of one JSON, this sketch is not handy, but easely to modify 
 * by opening once and let the "RequestAnswer" compleet.
 * This sketch was made by Laurens Korste from BOKTORROBOTICA.NL and can be used freely.
 */
 
//#include <WiFi.h>             //use this line for ESP32
#include <ESP8266WiFi.h>        //use this line for ESP8266

#include <ESP8266HTTPClient.h> // http web access library 


const char* ssid = "enter_your_ssid";           
const char* password = "enter_your_password"; 

// make an account by openweather for the key
char API_http[]= "http://api.openweathermap.org/data/2.5/weather?q=assen,nl&units=metric&appid=PUT_YOUR_ONE_KEY_HERE";


void setup()
{
  Serial.begin(115200);
  Serial.println();

  WiFi.begin(ssid, password);

  Serial.print("Connecting");
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println();

  Serial.print("Connected, IP address: ");
  Serial.println(WiFi.localIP());
}


void loop() {  // Change "humidity" in the value you like to have. Look into the JSON for the right name. (only the first will be taken.)
float Value = GetValueJson("humidity");               //Uit de JSON wordt de variabele "temp" opgevraagd.
Serial.print ("Value = ");
Serial.println(Value);
delay(120*1000);            // 2 minuten tijd tussen HTTP request. (Liever geen delay gebruiken.)
}

float GetValueJson(char ValueName[]){
    if (WiFi.status() != WL_CONNECTED) {                  //Check WiFi connection status
     Serial.println("Wifi-connectie failed");             //No WiFi connection. You can upgrade this part of the sketch to make a new connection or to reset the ESP.
  }else
  {
                Serial.println();
                Serial.println("GetVaueJSON : Wifi.status = connect, http request start ");
    HTTPClient http;                                        // Use library for HTTPClient
    http.begin(API_http);
    int httpCode = http.GET();                              // send the request and return errorcode. 
    if (httpCode > 0) {                                     // check the returning code > 0 is oké
      String RequestAnswer = http.getString();              //Get the request response RequestAnswer
      http.end();                                           //Close connection

      
      // Now we have the JSON in RequestAnswer. Now we can search for the data we need.
      int startPos = RequestAnswer.indexOf(ValueName);      //Position of valuename 
            //Serial.print("httprequest oké and return = ");'// uncommad this three lines to see the JSON in your Serial Monitor.
            //Serial.println(RequestAnswer);
            //Serial.print(ValueName); Serial.print(" found at: "); Serial.println(startPos);
      RequestAnswer=RequestAnswer.substring(startPos+1);      //Everything before we true away
      startPos=RequestAnswer.indexOf(":");                    //end of valuename and the begin of value
      RequestAnswer=RequestAnswer.substring(startPos+1);      //true away valuename from string
          
      int endPos1=RequestAnswer.indexOf(","); 
      int endPos2=RequestAnswer.indexOf("}");
      // abort at smallest to determine end position and separate the value
      if (endPos1<endPos2){
        RequestAnswer=RequestAnswer.substring(0,endPos1);   //nu alles achter de waarde weggooien zpdat waarde overblijft
      }
      else{
        RequestAnswer=RequestAnswer.substring(0,endPos2);
      }
      float ValueWaarde = RequestAnswer.toFloat(); 
              //Serial.print( "the found value for ");    //uncommand this four lines to see the value in your serial monitor
              //Serial.print(ValueName);
              //Serial.print(" is : ");
              //Serial.println(ValueWaarde);
      return ValueWaarde;
    }
    else {                                                //if request failes:
        Serial.print("http error code = ");
        Serial.print(httpCode);
        Serial.print(http.errorToString(httpCode).c_str());
    }
  }
  
}
